stages:
  - build
  - run
before_script:
  - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
build_dev:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - echo "test1"
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:app_dev$CI_COMMIT_SHORT_SHA       
      #tags:
      #- docker_runner
  rules:
    - if: '$CI_COMMIT_REF_NAME == "dev"'
      when: always
    
build_prod:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:app_prod$CI_COMMIT_SHORT_SHA
      #tags:
      #- docker_runner
  rules:
    - if: '$CI_COMMIT_REF_NAME == "master"'
      when: always

run_dev:
  stage: run
  #tags:
  #- docker_runner
  variables:
    NGINX_PORT: "8001"
    DEV_PROD: "registry.gitlab.com/mr.silin/less2.2:app_dev$CI_COMMIT_SHORT_SHA"
  script: 
    - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker-compose up -d
  rules:
    - if: '$CI_COMMIT_REF_NAME == "dev"'  
      when: always

run_prod:
  stage: run
  #tags:
  #  - docker_runner
  variables:
    NGINX_PORT: "8000"
    DEV_PROD: "registry.gitlab.com/mr.silin/less2.2:app_prod$CI_COMMIT_SHORT_SHA"
  script:
   - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
   - docker-compose up -d
  rules:
   - if: '$CI_COMMIT_REF_NAME == "master"'
     when: always

